=== debian/changelog ===
dune-istl (2.11.0-1) unstable; urgency=medium

  * New upstream release 2.11.0
  * Added gbp.conf for dep-14 branch layout
  * Added Salsa ci configuration alsa-ci.yml
  * Updated debian/copyright
  * d/patches: Removed patches already applied upstream.
  * d/control: Depend on dune-common >= 2.11~

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 06 Feb 2026 17:25:13 +0100

dune-istl (2.11.0-1~exp1) experimental; urgency=medium

  * New upstream release 2.11.0
  * Added gbp.conf for dep-14 branch layout
  * Added Salsa ci configuration alsa-ci.yml
  * Update changelog for 2.11.0-1~1.gbp8ec198 release

 -- Markus Blatt <markus@dr-blatt.de>  Wed, 28 Jan 2026 16:05:30 +0100
